/*!
  @file enums.h 
  @brief Global enum's used 
*/
#ifndef ENUMS_H
#define ENUMS_H

// global enums so they can be reused by classes that include this file
// without any castings

//! Cholesky solver to be used.
enum CHOL_SOLVER {SPRSBLKLLT, CHOLMOD};
//! Who is in charge of permuting constraints-related variables.
enum WHO_PERMUTES {CHOLESKY, USER_OF_CHOLESKY};
//! Matrix type; IDTY_IDTY= [I I] ; DIAG_DIAG= [D1 D2] ;
//! SPLITTING for linking constraints associated to split of variables: x_i=x_i+1 i=1...k-1
enum TYPE_MATRIX {GENERAL, NETWORK, IDENTITY, DIAGONAL, IDTY_IDTY, DIAG_DIAG, GEN_SYM_UPTR, SPLITTING, TRIDIAG_SHIFTED, DENSE_DIAG_DIAG};
//! Type of arc orientation for NETWORK matrices.
enum TYPE_ORIENTATION {ORIENTED, NONORIENTED};
//! Type of numbering for arrays: either start at 0 or at 1. Needed for mixing C and Fortran code.
enum NUMBERING {C_0, FORTRAN_1, NOT_COMPUTED};

#endif //ENUMS_H
